-- ****************************************************************************************************** --
-- Tickisms, By Richard
--
-- Constants:

local VERSION = "1.0";

-- Varibles needed by Addon
local petsummoned = 0;
local issummoned = 0;
local cID = 0;
local CName = 0;
local CSpellID = 0;
local icon = 0;
local mounted = 0;
local status = true;

-- Sayings for when you login to world
local Tickisms_Login_Array = {
	"I hate broccoli, and yet, in a certain sense, I am broccoli.",
	"Heh, heh. Those darn ninjas. They're wacky.",
	"Can't lose my name, it's on all my stationery!",
	"I feel just like Uncle Wiggly!",
	"Roof pig! Most unexpected.",
	"Mustache, I will NOT be mocked by you!",
	"Sanity, you're a madman!",
	"Why am I here? Why does my mind have wings? Why do blue midgets hit me with fish?!",
	"Sun worshipping dog launchers you face the Tick! and his dog Speak!",
	"Arthur, the fourth dimension is just one big crazy do not enter clambake of wierdity! and how does it work? Never you mind!",
	"I'm startin' to like the cut of this man's jibberish",
	"It started as a great day. No, a super day, perfect in every way; well, nigh-perfect really." };

-- Sayings for when you summon your mount
local Tickisms_mount_Array = {
        "The boots of evil were made for walkin'",
        "Arthur! Carmalita! Look Out! Runaway Whale!",
        "When evil sees a twin headed Arthur powered flying engine of justice barreling down upon it, great will be its trembling!",
        "He's probably out joyriding in my sleek chassis!",
        "Step on it, chum and don't spare the mucus!" };

-- Possible new sayings for future release
-- Secret crime viewfinder engaged. (Goggle Text)
-- We are not two men ... we are TEN men! (Zone into 10 MAN)
-- Villains, I say to you now, Knock off all that Evil!  (possible boss kill)
-- Need saying for rezing

-- command for slash
SLASH_TICKISMS1 = '/tickisms';

local TickismsFrame = CreateFrame("FRAME");
TickismsFrame:RegisterEvent("PLAYER_ENTERING_WORLD");
TickismsFrame:SetScript("OnEvent", function(self, event, ...)
return self[event](...) end);

-- ****************************************************************************************************** --
-- Function:  Turns off and on messages and displays usage
--
function SlashCmdList.TICKISMS(msg, editbox)
-- Any leading non-whitespaces is captured into command; the rest is capurted into rest
  local command, rest = msg:match("^(%S*)%s*(.-)$");

  if command == "off" and rest == "" then
    print ("tickisms is disabled");
    status = false;
  elseif command == "on" and rest == "" then
    print ("tickisms is enabled");
    status = true;
  elseif command == "status" and rest == "" then
    if status then 
      print ("Tickisms status: enabled"); else
      print ("Tickisms status: disabled");
    end
  else
   print ("usage: /tickisms on     - enables messages");
   print ("          /tickisms off      - disables messages");
   print ("          /tickisms status - prints current status");
   print ("          /tickisms help   - prints this message");
  end
end

-- ****************************************************************************************************** --
-- Function: say tickisms when entering combat (only say 30% of the time)
--
function TickismsFrame.PLAYER_REGEN_DISABLED()
  if math.random(100) >= 70 and status then
    SendChatMessage("Spoooooon","SAY");
  end
end

-- ****************************************************************************************************** --
-- Function: say tickisms when killing another player (not tested yet)
--
function TickismsFrame.PLAYER_PVP_KILLS_CHANGED()
  if status then
    sendChatMessage("Villains, I say to you now, Knock off all that Evil!","SAY");
  end
end

-- ****************************************************************************************************** --
-- Function: Determines if you summoned your companion pet or mount, if summoned then say a tickisms
--
function TickismsFrame.COMPANION_UPDATE()

--  This section for summon of companion pet  
  if petsummoned == 0 then
    for i=1,GetNumCompanions("CRITTER") do
      cID, CName, CSpellID, icon, issummoned = 	GetCompanionInfo("CRITTER",i);
      if issummoned == 1 then
        petsummoned = 1;
        if status then
          SendChatMessage("I'll call you Speak because that's what you do.","SAY");
        end
	break;
      end
    end
  else
    for i=1,GetNumCompanions("CRITTER") do
      CID, CName, CSpellID, icon, issummoned = 	GetCompanionInfo("CRITTER",i);
      if issummoned == 1 then break; end
    end
    if issummoned == nil  then
      petsummoned = 0;
    end
  end

--  This section for summon of mount
  if mounted == 0 then
    for i=1,GetNumCompanions("MOUNT") do
      cID, CName, CSpellID, icon, issummoned = 	GetCompanionInfo("MOUNT",i);
      if issummoned == 1 then
        mounted = 1;
        if status then
          SendChatMessage(Tickisms_mount_Array[math.random(table.getn(Tickisms_mount_Array))], "SAY");
        end
	break;
      end
    end
  else
    for i=1,GetNumCompanions("MOUNT") do
      CID, CName, CSpellID, icon, issummoned = 	GetCompanionInfo("MOUNT",i);
      if issummoned == 1 then break; end
    end
    if issummoned == nil  then
      mounted = 0;
    end
  end 
end

-- ****************************************************************************************************** --
-- Function: Prints saying if you recieve falling damage
-- 
function TickismsFrame.COMBAT_LOG_EVENT_UNFILTERED(self, event, ...)

  local timestamp, type, sourceGUID, sourceName, sourceFlags, destGUID, destName, destFlags = select(1, ...);
  local playerName = UnitName("player");

  if (destName=="FALLING") and (sourceFlags == playerName) and (status) then
    SendChatMessage("Gravity is a harsh mistress.","SAY");
  end
   
end

-- ****************************************************************************************************** --
-- Function: Sets everything for Player Entering World
--
function TickismsFrame.PLAYER_ENTERING_WORLD()
  print ("Tickisms: ", VERSION, " loaded");
  
  if status then
    SendChatMessage(Tickisms_Login_Array[math.random(table.getn(Tickisms_Login_Array))], "SAY");
  end

-- Determines if you have pet or mount out at start
  for i=1,GetNumCompanions("CRITTER") do
    cID, CName, CSpellID, icon, issummoned = 	GetCompanionInfo("CRITTER",i);
    if issummoned then 
      petsummoned = 1;
      break;
    end
  end

  if IsMounted() == 1 then
    mounted=1;
  end

-- Register events
  TickismsFrame:RegisterEvent("PLAYER_REGEN_DISABLED");
  TickismsFrame:RegisterEvent("PLAYER_PVP_KILLS_CHANGED");
  TickismsFrame:RegisterEvent("COMPANION_UPDATE");
  TickismsFrame:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED");

  TickismsFrame:UnregisterEvent("PLAYER_ENTERING_WORLD")
  TickismsFrame.PLAYER_ENTERING_WORLD = nil;

end
-- ****************************************************************************************************** --
